VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "AcroForms"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4140
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   4140
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   735
      Left            =   840
      TabIndex        =   0
      Top             =   720
      Width           =   2535
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "This example creates an Interactive Form."
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   2955
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Command1_Click()
   On Error GoTo err

   Dim outFile As String
   Dim AlertScript As String
   Dim f As Long
   Dim act As Long
   Dim keyStrokeAct As Long
   Dim formatAct As Long
   Dim keyStrokeAct2 As Long
   Dim formatAct2 As Long

   ' Error messages and warnings are passed to the error event function.
   If Not clsPDF.CreateNewPDFA("") Then ' The output file is opened later
      Exit Sub
   End If
   clsPDF.SetDocInfoA diCreator, "VB Example Project"
   clsPDF.SetDocInfoA diSubject, "Interactive Forms"
   clsPDF.SetDocInfoA diTitle, "Interactive Forms"
   clsPDF.SetDocInfoA diAuthor, "Jens Boschulte"
   clsPDF.SetViewerPreferences vpDisplayDocTitle, avNone
   ' Conversion of pages to templates is normally not required. Templates are required if
   ' the page should be scaled or used multiple times in a document, e.g. as background.
   ' See help file for further information.
   clsPDF.SetImportFlags ifImportAll Or ifImportAsPage
   If clsPDF.OpenImportFileA("../../test_files/taxform.pdf", ptOpen, "") < 0 Then
      clsPDF.FreePDF
      Exit Sub
   End If
   clsPDF.ImportPDFFile 1, 1#, 1#
   clsPDF.CloseImportFile

   ' Transparent field background
   clsPDF.SetFieldBackColor NO_COLOR

   clsPDF.EditPage 1

   clsPDF.SetCheckBoxChar ccCross4
   clsPDF.SetLineWidth 0#
   clsPDF.SetFieldBorderColor NO_COLOR

   f = clsPDF.CreateRadioButton("AntragsArt", "EinkommensSteuerErklrung", False, -1, 68.5, 745#, 16#, 16#)
   clsPDF.CreateCheckBox "", "Sparzulage", False, f, 68.5, 721#, 16#, 16#
   clsPDF.CreateCheckBox "", "VerlustErklrung", False, f, 247.5, 721#, 16#, 16#

   clsPDF.SetFontA "Courier", fsNone, 12#, True, cp1252
   clsPDF.CreateTextField "Finanzamt", -1, False, 0, 71#, 698#, 356#, 16#
   clsPDF.CreateTextField "Steuernummer", -1, False, 14, 71#, 673.5, 147#, 16#
   clsPDF.CreateTextField "Finanzamt_alt", -1, False, 0, 269.5, 673.5, 157#, 16#

   clsPDF.CreateCheckBox "Rckerstattung", "Ja", True, -1, 428.5, 673.5, 15#, 15#
   clsPDF.CreateTextField "Telefon", -1, False, 0, 285.5, 649#, 143#, 16#
   'Acrobat 7.0 ignores the character spacing, the only way to get the same result is to set the Comb flag.
   'See help file for further information.
   clsPDF.SetCharacterSpacing 7.2
   f = clsPDF.CreateTextField("Name", -1, False, 25, 71#, 625#, 357#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("Vorname", -1, False, 25, 71#, 601.5, 357#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("Geburtsdatum", -1, False, 10, 71#, 577.5, 113#, 16#)
   ' Create a custom date format action -> input example: 13.05.1971 or 13-05-1971 or 13/05/1971
   ' Two actions are required, one for the event onKeyStroke and one for the event onFormat.
   keyStrokeAct = clsPDF.CreateJSActionA("AFDate_KeystrokeEx(" + Chr(34) + "ddmmyyyy" + Chr(34) + ");")
   formatAct = clsPDF.CreateJSActionA("AFDate_FormatEx(" + Chr(34) + "ddmmyyyy" + Chr(34) + ");")

   ' Add both actions to the field
   clsPDF.AddActionToObj otField, oeOnKeyStroke, keyStrokeAct, f
   clsPDF.AddActionToObj otField, oeOnFormat, formatAct, f

   clsPDF.SetCharacterSpacing 0#
   f = clsPDF.CreateComboBox("Religion", False, -1, 186#, 577.5, 70#, 16#)
   clsPDF.AddValToChoiceFieldA f, "keine", "keine", True
   clsPDF.AddValToChoiceFieldA f, "Evang", "Evang.", False
   clsPDF.AddValToChoiceFieldA f, "Kath", "Kath.", False
   clsPDF.AddValToChoiceFieldA f, "andere", "andere", False

   clsPDF.CreateTextField "Beruf", -1, False, 0, 258#, 577.5, 171#, 16#

   clsPDF.SetCharacterSpacing 7.2
   f = clsPDF.CreateTextField("Strasse", -1, False, 25, 72#, 553.5, 356#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("PLZ", -1, False, 5, 72#, 529.5, 69#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   clsPDF.SetNumberFormat f, dsNoneDot, 0, nsRed, "", False

   f = clsPDF.CreateTextField("Wohnort", -1, False, 20, 144#, 529.5, 284#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False

   clsPDF.SetCharacterSpacing 0#
   clsPDF.SetFontA "Courier", fsNone, 11#, True, cp1252

   f = clsPDF.CreateTextField("VerheiratetSeit", -1, False, 10, 70#, 506#, 71#, 16#)
   ' We need another date format here. The date should be delimited with a dot.
   keyStrokeAct2 = clsPDF.CreateJSActionA("AFDate_KeystrokeEx(" + Chr(34) + "dd.mm.yyyy" + Chr(34) + ");")
   formatAct2 = clsPDF.CreateJSActionA("AFDate_FormatEx(" + Chr(34) + "dd.mm.yyyy" + Chr(34) + ");")
   clsPDF.AddActionToObj otField, oeOnKeyStroke, keyStrokeAct2, f
   clsPDF.AddActionToObj otField, oeOnFormat, formatAct2, f

   f = clsPDF.CreateTextField("VerwitwetSeit", -1, False, 10, 142#, 506#, 71#, 16#)
   clsPDF.AddActionToObj otField, oeOnKeyStroke, keyStrokeAct2, f
   clsPDF.AddActionToObj otField, oeOnFormat, formatAct2, f

   f = clsPDF.CreateTextField("GeschiedenSeit", -1, False, 10, 214#, 506#, 70#, 16#)
   clsPDF.AddActionToObj otField, oeOnKeyStroke, keyStrokeAct2, f
   clsPDF.AddActionToObj otField, oeOnFormat, formatAct2, f

   f = clsPDF.CreateTextField("GetrenntSeit", -1, False, 10, 286#, 506#, 142#, 16#)
   clsPDF.AddActionToObj otField, oeOnKeyStroke, keyStrokeAct2, f
   clsPDF.AddActionToObj otField, oeOnFormat, formatAct2, f

   clsPDF.SetCharacterSpacing 7.2
   clsPDF.SetFontA "Courier", fsNone, 12#, True, cp1252
   f = clsPDF.CreateTextField("EhefrauVorname", -1, False, 25, 72#, 458#, 356#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("EhefrauName", -1, False, 25, 72#, 434#, 356#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False

   f = clsPDF.CreateTextField("EhefrauGeburtdatum", -1, False, 10, 72#, 410#, 113#, 16#)
   ' Add both actions to the field
   clsPDF.AddActionToObj otField, oeOnKeyStroke, keyStrokeAct, f
   clsPDF.AddActionToObj otField, oeOnFormat, formatAct, f

   clsPDF.SetCharacterSpacing 0#
   f = clsPDF.CreateComboBox("EhefrauReligion", False, -1, 186#, 410#, 70#, 16#)
   clsPDF.AddValToChoiceFieldA f, "keine", "keine", True
   clsPDF.AddValToChoiceFieldA f, "Evang", "Evang.", False
   clsPDF.AddValToChoiceFieldA f, "Kath", "Kath.", False
   clsPDF.AddValToChoiceFieldA f, "andere", "andere", False

   clsPDF.CreateTextField "EhefrauBeruf", -1, False, 0, 258#, 410#, 171#, 16#
   clsPDF.CreateTextField "EhefrauStrasse", -1, False, 49, 71#, 385.5, 357#, 16#

   f = clsPDF.CreateRadioButton("Veranlagung", "Zusammen", False, -1, 68.5, 362#, 16#, 16#)
   clsPDF.CreateCheckBox "", "Getrennt", False, f, 140#, 362#, 16#, 16#
   clsPDF.CreateCheckBox "", "Eheschliessung", False, f, 212#, 362#, 16#, 16#

   f = clsPDF.CreateRadioButton("Guetergemeinschaft", "Ja", False, -1, 355.5, 362#, 16#, 16#)
   clsPDF.CreateCheckBox "", "Nein", False, f, 391.5, 362#, 16#, 16#

   clsPDF.SetCharacterSpacing 7.2
   f = clsPDF.CreateTextField("Konto", -1, False, 10, 71#, 313.5, 142#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   clsPDF.SetNumberFormat f, dsNoneDot, 0, nsRed, "", False
   f = clsPDF.CreateTextField("BLZ", -1, False, 8, 287#, 313.5, 112#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   clsPDF.SetNumberFormat f, dsNoneDot, 0, nsRed, "", False

   f = clsPDF.CreateTextField("Bank", -1, False, 25, 71#, 290#, 356#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False

   clsPDF.CreateCheckBox "AbwInhaber", "Ja", False, -1, 68.5, 265#, 16#, 16#
   f = clsPDF.CreateTextField("AbwKontoInhaber", -1, False, 21, 130#, 265.5, 298#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False

   f = clsPDF.CreateTextField("AbwEmpfName", -1, False, 25, 71#, 218#, 357#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("AbwEmpfVorname", -1, False, 25, 71#, 194#, 357#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("AbwEmpfStrasse", -1, False, 25, 71#, 170#, 357#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   f = clsPDF.CreateTextField("AbwEmpfPLZ", -1, False, 5, 71#, 146#, 72#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False
   clsPDF.SetNumberFormat f, dsNoneDot, 0, nsRed, "", False

   f = clsPDF.CreateTextField("AbwEmpfWohnort", -1, False, 20, 144#, 146.5, 284#, 16#)
   clsPDF.SetFieldFlags f, ffComb, False

   ' Add a reset button to the form
   clsPDF.SetFieldBorderColor vbBlack
   clsPDF.SetFieldBackColor RGB(&HC0, &HDC, &HC0)
   clsPDF.SetLineWidth 1#

   clsPDF.SetFontA "Helvetica", fsBold, 12#, True, cp1252
   f = clsPDF.CreateButtonA("Reset", "Zurcksetzen", -1, 440#, 730#, 120#, 25#)
   ' We want a bevelled border
   clsPDF.SetFieldBorderStyle f, bsBevelled
   act = clsPDF.CreateResetAction
   clsPDF.AddActionToObj otField, oeOnMouseUp, act, f

   clsPDF.SetCharacterSpacing 0#
   clsPDF.SetFontA "Courier", fsNone, 12#, True, cp1252
   clsPDF.WriteTextA 53#, 48#, Date

   clsPDF.SetFillColor RGB(&HFF, &H66, &H66)
   clsPDF.SetFontA "Helvetica", fsBold, 22#, False, cp1252
   clsPDF.WriteTextA 340#, 70#, "www.dynaforms.de"

   clsPDF.SetLineWidth 0#
   clsPDF.SetLinkHighlightMode hmPush
   clsPDF.SetAnnotFlags afReadOnly
   clsPDF.WebLinkA 340#, 64#, 204#, 22#, "http://www.dynaforms.de"

   AlertScript = "if (app.viewerVersion >= 7.0 && app.viewerVersion < 8.0)" + Chr(13) & _
      "{" + Chr(13) & _
      "app.alert(" & Chr(34) & "Due to bugs in Acrobat 7.0 character spacing does not work" & _
      " in text fields. We use the flag ffComb instead which is supported since" & _
      " Acrobat 6.0. However, if the field's format is controled by a JavaScript" & _
      " Action, we cannot set the flag because Acrobat 6.0 is then unable" & _
      " to display the field's text. Acrobat 7.0 has problems to place the" & _
      " the cursor in such fields but the final format will be correctly applied." & _
      " The problem is that if the form should work with Acrobat 6.0 we cannot set" & _
      " the flag ffComb to the date fields. It is also impossible to get the same" & _
      " result as with character spacing with the flag ffComb. So, what can we do to make the" & _
      " form compatible to all Acrobat versions? I really don't know! The easiest way" & _
      " would be to avoid the usage of such date formats." + Chr(34) + ");" + Chr(13) & _
      "}"

   clsPDF.AddJavaScriptA "VersionCheck", AlertScript
   clsPDF.EndPage

   ' No fatal error occurred?
   If clsPDF.HaveOpenDoc Then
      ' OK, now we can open the output file.
      outFile = App.Path + "\out.pdf"
      If Not clsPDF.OpenOutputFileA(outFile) Then
         clsPDF.FreePDF
         Exit Sub
      End If
      clsPDF.CloseFile
      ShellExecuteA Me.HWND, "open", outFile, vbNullString, vbNullString, 1
   End If
   Exit Sub
err:
   clsPDF.FreePDF
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Error"
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub

