VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Hello World"
   ClientHeight    =   2475
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4425
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2475
   ScaleWidth      =   4425
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   855
      Left            =   720
      TabIndex        =   0
      Top             =   720
      Width           =   3015
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "The output file is stored in the application directory."
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   3585
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub

Private Sub Command1_Click()
   On Error GoTo err

   Dim outFile As String
   outFile = App.Path + "\out.pdf"

   ' Error messages and warnings are passed to the error event function.
   clsPDF.CreateNewPDFA "" ' The ouput file is opened later

   clsPDF.SetDocInfoA diCreator, "VB Sample Project Hello World"
   clsPDF.SetDocInfoA diSubject, "How to create a pdf file"
   clsPDF.SetDocInfoA diTitle, "My first VB output"
   clsPDF.SetDocInfoA diAuthor, "Jens Boschulte"
   clsPDF.SetViewerPreferences vpDisplayDocTitle, avNone

   clsPDF.Append
   clsPDF.SetFontA "Arial", fsItalic, 30, False, cp1252
   clsPDF.WriteTextA 50#, 750#, "My first Visual Basic output"
   clsPDF.SetFontA "Arial", fsNone, 12#, False, cp1252
   clsPDF.WriteTextA 50#, 700#, "File: '" + outFile + "' created"
   clsPDF.SetFillColor vbBlue
   clsPDF.WriteTextA 50#, 680#, "Creation date: " + Str(Date) + " " + Str(Time)
   clsPDF.EndPage

   ' No fatal error occurred?
   If clsPDF.HaveOpenDoc Then
      ' OK, now we can open the output file.
      If Not clsPDF.OpenOutputFileA(outFile) Then
         clsPDF.FreePDF
         Exit Sub
      End If
      clsPDF.CloseFile
      ' If you want to encrypt the file, use CloseFileEx() instead.
      'clsPDF.CloseFileEx "", "test", kl128bit, rsDenyAll And Not rsPrint And Not rsPrintHighRes
      ShellExecuteA Me.HWND, "open", outFile, vbNullString, vbNullString, 1
   End If
   Exit Sub
err:
   clsPDF.FreePDF
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Error"
End Sub
