VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Personalize a PDF file"
   ClientHeight    =   2265
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4275
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2265
   ScaleWidth      =   4275
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.CommandButton Command1 
      Caption         =   "Create and view PDF file"
      Height          =   735
      Left            =   600
      TabIndex        =   0
      Top             =   720
      Width           =   3015
   End
   Begin VB.Label Label1 
      Caption         =   "This example demonstrates how an existing PDF file can be edited."
      Height          =   435
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4005
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ShellExecuteA Lib "shell32.dll" (ByVal HWND As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private WithEvents clsPDF As CPDF 'Activate event support
Attribute clsPDF.VB_VarHelpID = -1

Private Sub clsPDF_Error(ByVal Description As String, ByVal ErrType As Long, DoBreak As Boolean)
   MsgBox Description, vbExclamation, "Error"
   DoBreak = True ' We break processing if an error occurred!
End Sub

Private Sub Form_Load()
   On Error GoTo err
   Set clsPDF = New CPDF
   Exit Sub
err:
   MsgBox "Out of memory!", vbCritical, "Fatal error"
End Sub

Private Sub Form_Terminate()
   Set clsPDF = Nothing
End Sub

Private Sub Command1_Click()
   On Error GoTo err

   ' Error messages and warnings are passed to the error event function.
   clsPDF.CreateNewPDFA "" ' The output file is opened later

   If clsPDF.OpenImportFileA("../../test_files/taxform.pdf", ptOpen, "") < 0 Then
      clsPDF.FreePDF
      Exit Sub
   End If
   clsPDF.ImportPDFFile 1, 1#, 1#
   clsPDF.CloseImportFile

   clsPDF.SetDocInfoA diCreator, "VB Sample Project Personalize"
   clsPDF.SetDocInfoA diSubject, "How to edit existing pdf files"
   clsPDF.SetDocInfoA diTitle, "Edit a tax form"
   clsPDF.SetDocInfoA diAuthor, "Jens Boschulte"
   clsPDF.SetViewerPreferences vpDisplayDocTitle, avNone 'this is a clsPDF-1.4 feature (has no effect for Acrobat 4.0 or earlier versions)
   
   clsPDF.EditPage 1
   clsPDF.SetFontA "Courier", fsBold, 14#, False, cp1252
   clsPDF.WriteTextA 72.5, 748.5, "X"
   clsPDF.WriteTextA 74#, 701#, "Musterstadt"
   clsPDF.WriteTextA 74#, 677#, "252/1062/3323"
   clsPDF.BeginContinueText 74#, 628#
   clsPDF.SetLeading 24#
   clsPDF.SetCharacterSpacing 5.8
   clsPDF.AddContinueTextA "Mustermann"
   clsPDF.AddContinueTextA "Hermann"
   clsPDF.AddContinueTextA "22021963keineKaufmann"
   clsPDF.AddContinueTextA "Musterstrae 145"
   clsPDF.AddContinueTextA "12345Musterstadt"
   clsPDF.SetCharacterSpacing 0#
   clsPDF.ChangeFontSize 10#
   clsPDF.SetLeading 48#
   clsPDF.AddContinueTextA "04.05.1994"
   clsPDF.ChangeFontSize 14#
   clsPDF.SetCharacterSpacing 5.8
   clsPDF.AddContinueTextA "Sabine"
   clsPDF.AddContinueTextA "18121966 ev  Hausfrau"
   clsPDF.EndContinueText
   clsPDF.WriteTextA 72.5, 365#, "X"
   clsPDF.WriteTextA 396#, 365#, "X"
   clsPDF.BeginContinueText 74#, 316#
   clsPDF.SetLeading 24#
   clsPDF.AddContinueTextA "2346256780     76834560"
   clsPDF.AddContinueTextA "Sparkasse Musterstadt"
   clsPDF.EndContinueText
   clsPDF.WriteTextA 72.5, 269#, "X"
   clsPDF.SetCharacterSpacing 0#
   clsPDF.SetFontA "Courier", fsNone, 10#, False, cp1252
   clsPDF.WriteTextA 53#, 48#, Str(Date) + " " + Str(Time)
   clsPDF.SetFillColor RGB(&HFF, &H66, &H66)
   clsPDF.SetFontA "Helvetica", fsBold, 22#, False, cp1252
   clsPDF.WriteTextA 340#, 70#, "www.dynaforms.de"
   clsPDF.SetLineWidth 0#
   clsPDF.SetLinkHighlightMode hmPush
   clsPDF.SetAnnotFlags afReadOnly
   clsPDF.WebLinkA 340#, 64#, 204#, 22#, "http://www.dynaforms.de"
   clsPDF.EndPage

   ' No fatal error occurred?
   If clsPDF.HaveOpenDoc Then
      ' OK, now we can open the output file.
      Dim outFile As String
      outFile = App.Path + "\out.pdf"
      If Not clsPDF.OpenOutputFileA(outFile) Then
         clsPDF.FreePDF
         Exit Sub
      End If
      clsPDF.CloseFile
      ' If you want to encrypt the file, use CloseFileEx() instead.
      'clsPDF.CloseFileEx "", "test", kl128bit, rsDenyAll And Not rsPrint And Not rsPrintHighRes
      ShellExecuteA Me.HWND, "open", outFile, vbNullString, vbNullString, 1
   End If
   Exit Sub
err:
   clsPDF.FreePDF
   MsgBox err.Source & Chr(13) & err.Description, vbCritical, "Error"
End Sub
