/*
   This function creates an absolute path to avoid problems when using different
   compilers or project settings.
*/

void MakeAbsolutePath(char* ExeDir[], const char* Path, char* Out)
{
   char* src, *p, *ePtr;
   char* dst;
   if (!ExeDir)
   {
      Out[0] = 0;
      return;
   }
   src = ExeDir[0];
   p   = src;
   while (*p) ++p;
   while (p > src && *p != '/' && *p != '\\') --p;
   --p;
   while (p > src && *p != '/' && *p != '\\') --p;
   ++p;
   ePtr = p;
   p    = src;
   dst  = Out;
   while (p < ePtr)
   {
      *dst++ = *p++;
   }
   src = (char*)Path;
   while (*src)
   {
      *dst++ = *src++;
   }
   *dst = 0;
}
